---
title: Send Risk Evaluation Feedback
description: This sample uses the riskFeedback endpoint to send feedback regarding the results of three different risk evaluations that were carried out.
component: pingone-api
page_id: pingone-api:protect:risk-evaluations/send_risk_evaluation_feedback
canonical_url: https://developer.pingidentity.com/pingone-api/protect/risk-evaluations/send_risk_evaluation_feedback.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Send Risk Evaluation Feedback

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/riskFeedback
```

This sample uses the `riskFeedback` endpoint to send feedback regarding the results of three different risk evaluations that were carried out.

Note that the `reason` parameter is optional, and is not provided for the third risk evaluation.

### Prerequisites

* Refer to [Risk Evaluations](#risk-evaluations) for important overview information.

* [Create a Risk Policy Set](#post-create-risk-policy-set)

> **Collapse: Request Model**
>
> For complete property descriptions, refer to "Risk evaluation feedback data model" in[Risk Evaluations](#risk-evaluations).
>
> | Property                                             | Type   | Required? |
> | ---------------------------------------------------- | ------ | --------- |
> | `evaluationFeedbackItems`                            | Array  | Required  |
> | `evaluationFeedbackItems[].feedbackCategory`         | String | Required  |
> | `evaluationFeedbackItems[].reason`                   | String | Optional  |
> | `evaluationFeedbackItems[].riskEvaluation.createdAt` | Date   | Optional  |
> | `evaluationFeedbackItems[].riskEvaluation.id`        | String | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
  "evaluationFeedbackItems":[
    {
      "riskEvaluation": {
            "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
            "createdAt": "2024-05-01T13:44:33.417Z"
       },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
            "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
       },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
            "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
       },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
   ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/riskFeedback' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "evaluationFeedbackItems":[
    {
      "riskEvaluation": {
            "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
            "createdAt": "2024-05-01T13:44:33.417Z"
       },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
            "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
       },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
            "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
       },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
   ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""evaluationFeedbackItems"":[" + "\n" +
@"    {" + "\n" +
@"      ""riskEvaluation"": { " + "\n" +
@"            ""id"": ""15f1d245-33b3-4dba-849d-4df4b64b2d42""," + "\n" +
@"            ""createdAt"": ""2024-05-01T13:44:33.417Z""" + "\n" +
@"       }," + "\n" +
@"      ""feedbackCategory"": ""FRIENDLY_BOT""," + "\n" +
@"      ""reason"": ""INTERNAL_AUTOMATION""" + "\n" +
@"    }," + "\n" +
@"    {" + "\n" +
@"      ""riskEvaluation"": { " + "\n" +
@"            ""id"": ""d1b638b4-638e-4c56-8fc6-872691c1bab1""" + "\n" +
@"       }," + "\n" +
@"      ""feedbackCategory"": ""FALSE_HIGH_RISK""," + "\n" +
@"      ""reason"": ""COMPANY_VPN""" + "\n" +
@"    }," + "\n" +
@"    {" + "\n" +
@"      ""riskEvaluation"": { " + "\n" +
@"            ""id"": ""35f1d245-33b3-4dba-849d-4df4b64b2d45""" + "\n" +
@"       }," + "\n" +
@"      ""feedbackCategory"": ""FALSE_HIGH_RISK""" + "\n" +
@"    }  " + "\n" +
@"   ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"
  method := "POST"

  payload := strings.NewReader(`{
  "evaluationFeedbackItems":[
    {
      "riskEvaluation": {
            "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
            "createdAt": "2024-05-01T13:44:33.417Z"
       },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
            "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
       },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
            "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
       },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
   ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/riskFeedback HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "evaluationFeedbackItems":[
    {
      "riskEvaluation": {
            "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
            "createdAt": "2024-05-01T13:44:33.417Z"
       },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
            "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
       },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
            "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
       },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
   ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"evaluationFeedbackItems\":[\n    {\n      \"riskEvaluation\": { \n            \"id\": \"15f1d245-33b3-4dba-849d-4df4b64b2d42\",\n            \"createdAt\": \"2024-05-01T13:44:33.417Z\"\n       },\n      \"feedbackCategory\": \"FRIENDLY_BOT\",\n      \"reason\": \"INTERNAL_AUTOMATION\"\n    },\n    {\n      \"riskEvaluation\": { \n            \"id\": \"d1b638b4-638e-4c56-8fc6-872691c1bab1\"\n       },\n      \"feedbackCategory\": \"FALSE_HIGH_RISK\",\n      \"reason\": \"COMPANY_VPN\"\n    },\n    {\n      \"riskEvaluation\": { \n            \"id\": \"35f1d245-33b3-4dba-849d-4df4b64b2d45\"\n       },\n      \"feedbackCategory\": \"FALSE_HIGH_RISK\"\n    }  \n   ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/riskFeedback",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "evaluationFeedbackItems": [
      {
        "riskEvaluation": {
          "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
          "createdAt": "2024-05-01T13:44:33.417Z"
        },
        "feedbackCategory": "FRIENDLY_BOT",
        "reason": "INTERNAL_AUTOMATION"
      },
      {
        "riskEvaluation": {
          "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
        },
        "feedbackCategory": "FALSE_HIGH_RISK",
        "reason": "COMPANY_VPN"
      },
      {
        "riskEvaluation": {
          "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
        },
        "feedbackCategory": "FALSE_HIGH_RISK"
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/riskFeedback',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "evaluationFeedbackItems": [
      {
        "riskEvaluation": {
          "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
          "createdAt": "2024-05-01T13:44:33.417Z"
        },
        "feedbackCategory": "FRIENDLY_BOT",
        "reason": "INTERNAL_AUTOMATION"
      },
      {
        "riskEvaluation": {
          "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
        },
        "feedbackCategory": "FALSE_HIGH_RISK",
        "reason": "COMPANY_VPN"
      },
      {
        "riskEvaluation": {
          "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
        },
        "feedbackCategory": "FALSE_HIGH_RISK"
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"

payload = json.dumps({
  "evaluationFeedbackItems": [
    {
      "riskEvaluation": {
        "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
        "createdAt": "2024-05-01T13:44:33.417Z"
      },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
        "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
      },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
        "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
      },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/riskFeedback');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "evaluationFeedbackItems":[\n    {\n      "riskEvaluation": { \n            "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",\n            "createdAt": "2024-05-01T13:44:33.417Z"\n       },\n      "feedbackCategory": "FRIENDLY_BOT",\n      "reason": "INTERNAL_AUTOMATION"\n    },\n    {\n      "riskEvaluation": { \n            "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"\n       },\n      "feedbackCategory": "FALSE_HIGH_RISK",\n      "reason": "COMPANY_VPN"\n    },\n    {\n      "riskEvaluation": { \n            "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"\n       },\n      "feedbackCategory": "FALSE_HIGH_RISK"\n    }  \n   ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "evaluationFeedbackItems": [
    {
      "riskEvaluation": {
        "id": "15f1d245-33b3-4dba-849d-4df4b64b2d42",
        "createdAt": "2024-05-01T13:44:33.417Z"
      },
      "feedbackCategory": "FRIENDLY_BOT",
      "reason": "INTERNAL_AUTOMATION"
    },
    {
      "riskEvaluation": {
        "id": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
      },
      "feedbackCategory": "FALSE_HIGH_RISK",
      "reason": "COMPANY_VPN"
    },
    {
      "riskEvaluation": {
        "id": "35f1d245-33b3-4dba-849d-4df4b64b2d45"
      },
      "feedbackCategory": "FALSE_HIGH_RISK"
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n  \"evaluationFeedbackItems\":[\n    {\n      \"riskEvaluation\": { \n            \"id\": \"15f1d245-33b3-4dba-849d-4df4b64b2d42\",\n            \"createdAt\": \"2024-05-01T13:44:33.417Z\"\n       },\n      \"feedbackCategory\": \"FRIENDLY_BOT\",\n      \"reason\": \"INTERNAL_AUTOMATION\"\n    },\n    {\n      \"riskEvaluation\": { \n            \"id\": \"d1b638b4-638e-4c56-8fc6-872691c1bab1\"\n       },\n      \"feedbackCategory\": \"FALSE_HIGH_RISK\",\n      \"reason\": \"COMPANY_VPN\"\n    },\n    {\n      \"riskEvaluation\": { \n            \"id\": \"35f1d245-33b3-4dba-849d-4df4b64b2d45\"\n       },\n      \"feedbackCategory\": \"FALSE_HIGH_RISK\"\n    }  \n   ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/riskFeedback")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "771f8a3b-11cd-485a-a738-e521f2c1ea81",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2024-05-16T14:36:33.849Z",
    "updatedAt": "2024-05-16T14:36:33.849Z"
}
```
